<template>
  <q-page>
    <q-page-sticky position="top-right">
      <div class="column" style="min-width: 20em">
        <q-btn glossy color="accent" :label="$t('tables.exportRoster')"
               class="q-mt-lg q-ml-lg q-mr-lg" @click="exportExcel()" />
        <q-card class="q-ma-md">
          <q-card-section>
            <div class="text-h6">{{ $t('tables.importResults.heading') }}</div>
            <q-file square outlined class="bg-grey-4" :label="$t('tables.importResults.dragHere')"
                    v-model="odsFileToImport" accept=".ods" :filter="checkFileType"
                    @update:model-value="importExcel" @rejected="onFileRejected"
            />
          </q-card-section>
        </q-card>
      </div>
    </q-page-sticky>

    <div class="row">
      <div class="q-drawer-container" style="width: 270px">
        <aside class="q-drawer q-drawer-left scroll bg-grey-3 q-drawer-normal"
          style="transform: translateX(0px); position: relative;">
          <q-list no-border link inset-delimiter padding>
            <q-input dense color="primary" v-model="searchId"
                     class="q-ml-md q-mr-md"
                     :label="$t('tables.searchById')"
                     @keyup="idKeyPressed">
              <template v-slot:before>
                <q-icon name="fab fa-creative-commons-by" />
              </template>
            </q-input>

            <q-separator />

            <q-input v-model="ctgFilter" :label="$t('default.categoryFilter')"
                     class="q-ml-md q-mr-md">
              <template v-slot:append>
                <q-icon name="fab fa-searchengin" />
              </template>
            </q-input>
            <q-item v-for="ctg in filteredCategoryData"
                    class="cursor-pointer"
                    clickable
                    :key="ctg._id" @click="changeCategory(ctg._id)">
              <q-item-section avatar>
                <q-icon color="primary" name="fas fa-users" />
              </q-item-section>
              <q-item-section>
                <q-item-label>{{ ctg.name }}</q-item-label>
                <q-item-label caption>{{ ctg.ageTo }}</q-item-label>
              </q-item-section>
              <q-item-section avatar right
                              v-if="ctg._id === selectedCategory">
                <q-icon name="fas fa-arrow-circle-right"/>
              </q-item-section>
            </q-item>
          </q-list>
        </aside>
      </div>

      <div class="q-page-container">
        <div class="flex column">
          <div class="flex row q-ma-md" style="min-width: 700px">
            <div class="col-2 q-mr-md" v-for="option in editRowOptions"
                 :key="option._id">
              <component :is="option.type"
                         :key="option._id" v-model="editorPerson[option.model]"
                         :type="option.subtype" :ref="option.model"
                         :label="option.label"
                         :readonly="option.readonly || typeof editorPerson._id === 'undefined'"
                         @keyup="keyPressed"/>
            </div>
            <div class="col-1">
              <q-btn glossy dense color="secondary" icon="far fa-check-circle"
                     :disabled="typeof editorPerson._id === 'undefined'"
                     @click="saveResults()" style="width: 50px; height: 100%"/>
            </div>
          </div>

          <table-with-records :title = "$t('tables.results.h1')"
                              :rows = "tableData"
                              :columns = "columns"
                              show-edit
                              @loadDataFromDb = "loadDataFromDb"
                              @editRow = "editRow($event)"
                              />
        </div>
      </div>
    </div>

    <q-dialog v-model="importDialogShow" persistent>
      <q-card style="min-width: 600px">
        <q-card-section>
          <div class="text-h6">{{ $t('tables.importResults.checkHeading') }}</div>
        </q-card-section>

        <q-card-section>
          <table-with-records v-for = "ctg in importDialogData" :key="ctg.header.id"
                              :title = "ctg.header.label"
                              :rows = "ctg.rowsToDisplay"
                              :columns = "ctg.columns"
                              hide-pagination
          />
        </q-card-section>

        <q-card-actions align="right" class="text-primary">
          <q-btn flat :label="$t('register.import.cancel')" v-close-popup />
          <q-btn flat :label="$t('register.import.ok')"
                 v-close-popup @click="doImportExcel" />
        </q-card-actions>
      </q-card>
    </q-dialog>
  </q-page>
</template>

<script setup lang="js">
import log from 'src/service/messaging-service';
import ux from 'src/service/ux-service';
import TableWithRecords from '../components/TableWithRecords.vue';
import {computed, onMounted, reactive, ref, toRaw} from 'vue';
import Person from 'src/model/person';
import {useQuasar} from 'quasar';

const ipcMain = window.ipcMain;
const $q = useQuasar();
const $t = log.getI18n();
const selectedCategory =  ref('');
const ctgFilter = ref('');
const categoryData =  reactive([]);
const columns =  reactive([]);
const columnsData =  reactive([]);
const tableData =  reactive([]);
const editRowOptions =  reactive([]);
const editorPerson =  reactive(new Person());
const pagination =  reactive({ rowsPerPage: 0 });
const searchId = ref('');
const searchedPerson = ref(null);
const odsFileToImport = ref(null);
const importDialogShow = ref(false);
const importDialogData = ref([]);

// reference to _id editbox
const _id = ref(null);

const filteredCategoryData = computed(() =>
  categoryData.filter((ctg) =>
    // eslint-disable-next-line implicit-arrow-linebreak
    ctg.name.toLowerCase().includes(ctgFilter.value.toLowerCase())
  )
)

async function ctgLoadFromDb() {
  const response = await ipcMain.send('category-get-all-data');
  if (response.status === 'fail') log.error(response.message);
  else {
    categoryData.splice(0, categoryData.length, ...response.message);
    selectedCategory.value = categoryData[0]._id;
    await discLoadFromDb();
  }
}

async function discLoadFromDb() {
  const response = await ipcMain.send('disciple-filter-data', toRaw(selectedCategory.value));
  if (response.status === 'fail') {
    log.error(response.message);
  } else {
    fillColumns(response.message);
    await loadDataFromDb();
  }
}

async function loadDataFromDb() {
  const response = await ipcMain.send('person-filter-data', { categoryId: selectedCategory.value });
  if (response.status === 'fail') {
    log.error(response.message);
  } else {
    tableData.splice(0, tableData.length, ...response.message.map((row) => humanizeDbData(row)));

    editSearchedPerson();
  }
}

function changeCategory(ctgId) {
  cleanupEditRow();
  selectedCategory.value = ctgId;
  discLoadFromDb();
}

function fillColumns(disciples) {
  columnsData.splice(0, columnsData.length, ...disciples);
  columns.splice(0, columns.length, {
    name: 'fullName',
    field: 'fullName',
    label: 'Jméno',
  });
  disciples.forEach((row) => {
    columns.push({
      name: row._id,
      field: row._id,
      label: row.label,
    });
  });
  columns.push({
    name: 'startingNumber',
    field: 'startingNumber',
    label: 'Start. #',
  });
  columns.push({ name: 'editBtn' });

  fillEditRow(disciples);
}

function fillEditRow(disciples) {
  editRowOptions.splice(0, editRowOptions.length, {
    type: 'QInput',
    _id: '_id',
    model: 'startingNumber',
    readonly: true,
    subtype: 'number',
    label: 'Start. #',
  });
  disciples.forEach((row) => {
    editRowOptions.push({
      type: 'QInput',
      _id: row._id,
      model: row._id,
      readonly: false,
      subtype: (row.datatype === 'number' || row.datatype === 'fp' ? 'number' : 'text'),
      label: row.label,
    });
  });
}

function editRow(person) {
  const _editorPerson = { _id: person.row._id, startingNumber: person.row.startingNumber, _entity: person.row._entity };
  columnsData.forEach((col) => {
    _editorPerson[col._id] = person.row[col._id];
  });
  Object.assign(editorPerson, { ..._editorPerson });
}

function editSearchedPerson() {
  if (searchedPerson.value != null) {
    const persons = tableData.filter((row) => row._id === searchedPerson.value);
    // person.row._entity = searchedPerson;
    if (persons.length > 0) {
      editRow({ row: persons[0] });
      searchedPerson.value = null;

      const _idValue = columnsData[0]._id;
      if (_idValue && _id) _id.value.focus();
    }
  }
}

function cleanupEditRow() {
  Object.keys(editorPerson).forEach(key => { delete editorPerson[key] });
  fillEditRow(columnsData);
}

async function saveResults() {
  const entity = toRaw(editorPerson._entity);
  columnsData.forEach((col) => {
    if (col.datatype === 'time') {
      entity[col._id] = ux.unformatTime(editorPerson[col._id]);
    } else {
      entity[col._id] = editorPerson[col._id];
    }
  });
  const response = await ipcMain.send('person-save', entity);
  if (response.status === 'fail') log.error(response.message);
  else {
    await loadDataFromDb();
    cleanupEditRow();
  }
}

async function doImportExcel() {
  const response = await ipcMain.send('save-imported-results', toRaw(importDialogData.value));
  if (response.status === 'fail') {
    log.error(response.message);
  } else {
    log.info($t('tables.importResults.success'));
    await loadDataFromDb();
  }
}

async function exportExcel() {
  const items = categoryData.map((ctg) => ({ label: ctg.name, value: ctg._id }));

  const configObj = {
    title: $t('tables.saveToOds'),
    message: $t('tables.saveToOdsMessage'),
    options: {
      type: 'checkbox',
      model: [],
      items,
    },
    cancel: true,
    preventClose: true,
    color: 'secondary',
  };

  $q.dialog(configObj)
    .onOk(async (dialogResult) => {
      const exportPath = await ipcMain.send('export-roster', dialogResult)
      log.info($t('tables.exportSuccessfull', { exportPath }));
    });
}

function importExcel(file) {
  const reader = new FileReader();
  reader.onload = async (e) => {
    const response = await ipcMain.send('import-results', e.target.result);
    if (response.status === 'fail') {
      log.error(response.message);
    } else {
      importDialogData.value.splice(0, importDialogData.value.length, ...response.message);
      importDialogData.value.forEach((ctgMessage) => {
        ctgMessage.rowsToDisplay = [];
        ctgMessage.rows.forEach((row) => {
          const rowToDisplay = { ...row };
          ctgMessage.columns.forEach((col) => {
            if (col.datatype === 'time') {
              rowToDisplay[col.field] = ux.formatTime(rowToDisplay[col.field]);
            }
          });
          ctgMessage.rowsToDisplay[ctgMessage.rowsToDisplay.length] = rowToDisplay;
        });
      });
      importDialogShow.value = true;
    }

  };
  reader.readAsBinaryString(file);
}

function keyPressed(ev) {
  if (ev.key === 'Enter') {
    saveResults();
  }
}

async function idKeyPressed(ev) {
  if (ev.key === 'Enter') {
    const response = await ipcMain.send('person-by-starting-number', searchId.value);
    if (response.status === 'fail') {
      log.error(response.message);
    } else if (response.message.length === 0) {
      log.info(`Startvní číslo ${searchId.value} neexistuje`);
    } else if (response.message[0].resigned) {
      log.info(
        $t('tables.personIsResigned',
          { lastName: response.message[0].lastName, firstName: response.message[0].firstName }),
      );
    } else {
      changeCategory(response.message[0].categoryId);
      searchedPerson.value = response.message[0]._id;
    }
    searchId.value = '';
    Object.assign(editorPerson, new Person());
  }
}

function checkFileType(files) {
  return files.filter((file) => file.type === 'application/vnd.oasis.opendocument.spreadsheet');
}

function onFileRejected(rejectedEntries) {
  $q.notify({
    type: 'negative',
    message: `${rejectedEntries[0].file.name} is not a valid .ods file`,
  });
}

function humanizeDbData(row) {
  const rowEntity = {
    _id: row._id,
    startingNumber: row.startingNumber,
    fullName: `${row.lastName} ${row.firstName}`,
    resigned: row.resigned,
    _entity: row,
  };
  columnsData.forEach((col) => {
    if (col.datatype === 'time') {
      rowEntity[col._id] = ux.formatTime(row[col._id]);
    } else {
      rowEntity[col._id] = row[col._id];
    }
  });
  return rowEntity;
}

onMounted(() => {
  // once mounted, we need to trigger the initial server data fetch
  ctgLoadFromDb();
});
</script>

<style>
</style>
